#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int N;
vector<int> P, T;
vector<vector<int> > kam, kolko;

vector<long long> bfs(int start) {
    vector<long long> dist(N,1LL<<62);
    dist[start] = 0;
    queue<int> Q;
    Q.push(start);
    while (!Q.empty()) {
        int kde = Q.front(); Q.pop();
        for (unsigned i=0; i<kam[kde].size(); ++i) {
            int k=kam[kde][i], c=kolko[kde][i];
            if (dist[k] <= dist[kde]+c) continue;
            dist[k] = dist[kde]+c;
            Q.push(k);
        }
    }
    return dist;
}

int main() {
    cin >> N;
    P.resize(N); for (int n=0; n<N; ++n) cin >> P[n];
    T.resize(N); for (int n=0; n<N; ++n) cin >> T[n];
    kam.resize(N); kolko.resize(N);
    for (int n=0; n<N-1; ++n) {
        int x,y,c; cin >> x >> y >> c; --x; --y;
        kam[x].push_back(y); kolko[x].push_back(c);
        kam[y].push_back(x); kolko[y].push_back(c);
    }

    vector< pair<int,int> > order;
    for (int n=0; n<N; ++n) order.push_back(make_pair(P[n],n));
    sort( order.begin(), order.end() );

    vector<long long> best(N,-1);
    for (int n=0; n<N; ++n) {
        int kde = order[n].second;
        best[kde] = 1LL * P[kde] * T[kde];

        vector<long long> dist = bfs(kde);
        long long add = 0;

        for (int i=0; i<N; ++i) if (best[i]!=-1) if (T[kde]+dist[i] < T[i]) {
            long long c = T[kde]+dist[i];
            add = max( add, best[i] - 1LL*c*P[i] );
        }
        best[kde] += add;
    }
    cout << *max_element(best.begin(),best.end()) << endl;

    /*
    cerr << N << endl;
    cerr << "P " << *min_element(P.begin(),P.end()) << " " << *max_element(P.begin(),P.end()) << endl;
    cerr << "T " << *min_element(T.begin(),T.end()) << " " << *max_element(T.begin(),T.end()) << endl;
    int minc=1234567890, maxc=0;
    for (int n=0; n<N; ++n) for (unsigned i=0; i<kolko[n].size(); ++i) { minc=min(minc,kolko[n][i]); maxc=max(maxc,kolko[n][i]); }
    cerr << "costs " << minc << " " << maxc << endl;
    */
}
